#ifndef _EVENTLOG_H
#define _EVENTLOG_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _SQLESERVER
	#ifdef _EVENT_LOG_BUILD
	#include "../SQLEServer/Source/Routines.h"
	#include "EventMsg/EventMsg.h"
	#else
	#include "../../SharedSource/EventMsg/EventMsg.h"
	#endif

	#define EVENTLOG_NAME "SQL-Exchange (Server)"
#elif _SQLECLIENT
	#ifdef _EVENT_LOG_BUILD
	#include "../SQLEClient/Source/Routines.h"
	#include "EventMsg/EventMsg.h"
	#else
	#include "../../SharedSource/EventMsg/EventMsg.h"
	#endif

	#define EVENTLOG_NAME "SQL-Exchange (Client)"
#else
	#error "You must define either _SQLESERVER or _SQLECLIENT"
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool RegisterEvents(void);
bool RecordWarn(const char *sMsg);
bool RecordError(const char *sMsg);
bool RecordInfo(const char *sMsg);
bool RecordEvent(WORD dwEventType, DWORD dwEventID, WORD wCategory, const char *sMsg);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
